<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: matrix_utilities_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_571b715927b0d4b7bee37d60dac387ec.html">matrix</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">matrix_utilities_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2006  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_MATRIx_UTILITIES_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_MATRIx_UTILITIES_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;matrix_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;complex&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../pixel.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../geometry/rectangle.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#inclue &lt;vector&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//                                   Simple matrix utilities </span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">const</span> matrix_exp diag (</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    );</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">struct </span>diag_exp</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    {</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">typedef</span> type_of_expression_returned_by_diag type;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    };</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">const</span> matrix_exp diagm (</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    );</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keyword">const</span> matrix_exp trans (</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    );</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">const</span> matrix_type::type dot (</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m1,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m2</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    );</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keyword">const</span> matrix_exp lowerm (</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    );</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keyword">const</span> matrix_exp lowerm (</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> scalar_value</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    );</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keyword">const</span> matrix_exp upperm (</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    );</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">const</span> matrix_exp upperm (</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> scalar_value</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    );</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keyword">const</span> matrix_exp make_symmetric (</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    );</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordtype">long</span> NR, </div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordtype">long</span> NC, </div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        T val</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        &gt;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keyword">const</span> matrix_exp uniform_matrix (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    );</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160; </div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordtype">long</span> NR, </div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordtype">long</span> NC</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        &gt;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keyword">const</span> matrix_exp uniform_matrix (</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keyword">const</span> T&amp; val</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    );</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160; </div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        &gt;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keyword">const</span> matrix_exp uniform_matrix (</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="keywordtype">long</span> nc,</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="keyword">const</span> T&amp; val</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    );</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160; </div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keyword">const</span> matrix_exp ones_matrix (</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; mat</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    );</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160; </div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        &gt;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="keyword">const</span> matrix_exp ones_matrix (</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keywordtype">long</span> nc</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    );</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160; </div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <span class="keyword">const</span> matrix_exp zeros_matrix (</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; mat</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    );</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160; </div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        &gt;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="keyword">const</span> matrix_exp zeros_matrix (</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keywordtype">long</span> nc</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    );</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160; </div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keyword">const</span> matrix_exp identity_matrix (</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; mat</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    );</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160; </div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        &gt;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="keyword">const</span> matrix_exp identity_matrix (</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        <span class="keywordtype">long</span> N</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    );</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keywordtype">long</span> N</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        &gt;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    <span class="keyword">const</span> matrix_exp identity_matrix (</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    );</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160; </div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keyword">const</span> matrix_exp linspace (</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keywordtype">double</span> start,</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keywordtype">double</span> end,</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        <span class="keywordtype">long</span> num</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    );</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160; </div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    <span class="keyword">const</span> matrix_exp logspace (</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        <span class="keywordtype">double</span> start,</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        <span class="keywordtype">double</span> end,</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        <span class="keywordtype">long</span> num</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    );</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keyword">const</span> matrix_exp linpiece (</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> val,</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; joints</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    );</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160; </div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="keywordtype">long</span> R,</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        <span class="keywordtype">long</span> C</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;        &gt;</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;    <span class="keyword">const</span> matrix_exp rotate (</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;    );</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160; </div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    <span class="keyword">const</span> matrix_exp fliplr (</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;    );</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160; </div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    <span class="keyword">const</span> matrix_exp flipud (</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    );</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160; </div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;    <span class="keyword">const</span> matrix_exp flip (</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    );</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160; </div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;    <span class="keyword">const</span> matrix_exp reshape (</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        <span class="keywordtype">long</span> rows,</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        <span class="keywordtype">long</span> cols</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;    );</div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160; </div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;    <span class="keyword">const</span> matrix_exp reshape_to_column_vector (</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;    );</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160; </div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;        <span class="keywordtype">long</span> R,</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;        <span class="keywordtype">long</span> C</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;        &gt;</div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;    <span class="keyword">const</span> matrix_exp removerc (</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;    );</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160; </div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;    <span class="keyword">const</span> matrix_exp removerc (</div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;        <span class="keywordtype">long</span> R,</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;        <span class="keywordtype">long</span> C</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;    );</div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160; </div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;        <span class="keywordtype">long</span> R</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;        &gt;</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;    <span class="keyword">const</span> matrix_exp remove_row (</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;    );</div><div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160; </div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;    <span class="keyword">const</span> matrix_exp remove_row (</div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;        <span class="keywordtype">long</span> R</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;    );</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160; </div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;        <span class="keywordtype">long</span> C</div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;        &gt;</div><div class="line"><a name="l00610"></a><span class="lineno">  610</span>&#160;    <span class="keyword">const</span> matrix_exp remove_col (</div><div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;    );</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160; </div><div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;    <span class="keyword">const</span> matrix_exp remove_col (</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;        <span class="keywordtype">long</span> C</div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;    );</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160; </div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;       <span class="keyword">typename</span> target_type</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;       &gt;</div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;    <span class="keyword">const</span> matrix_exp matrix_cast (</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;    );</div><div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160; </div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;        <span class="keywordtype">long</span> NR,</div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;        <span class="keywordtype">long</span> NC,</div><div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;        <span class="keyword">typename</span> MM,</div><div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;        <span class="keyword">typename</span> U,</div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;        &gt;</div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;    <span class="keywordtype">void</span> set_all_elements (</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; m,</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;        U value</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;    );</div><div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160; </div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;    <span class="keyword">const</span> matrix_exp::matrix_type tmp (</div><div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160;    );</div><div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00686"></a><span class="lineno">  686</span>&#160; </div><div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160;        <span class="keywordtype">long</span> NR, </div><div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;        <span class="keywordtype">long</span> NC, </div><div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;        <span class="keyword">typename</span> MM, </div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;        &gt;</div><div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;    uint32 hash (</div><div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;        <span class="keyword">const</span> matrix&lt;T,NR,NC,MM,L&gt;&amp; item,</div><div class="line"><a name="l00696"></a><span class="lineno">  696</span>&#160;        uint32 seed = 0</div><div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;    );</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160; </div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;    <span class="comment">// if matrix_exp contains non-complex types (e.g. float, double)</span></div><div class="line"><a name="l00718"></a><span class="lineno">  718</span>&#160;    <span class="keywordtype">bool</span> equal (</div><div class="line"><a name="l00719"></a><span class="lineno">  719</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00720"></a><span class="lineno">  720</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b,</div><div class="line"><a name="l00721"></a><span class="lineno">  721</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> epsilon = 100*std::numeric_limits&lt;matrix_exp::type&gt;::epsilon()</div><div class="line"><a name="l00722"></a><span class="lineno">  722</span>&#160;    );</div><div class="line"><a name="l00733"></a><span class="lineno">  733</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00734"></a><span class="lineno">  734</span>&#160; </div><div class="line"><a name="l00735"></a><span class="lineno">  735</span>&#160;    <span class="comment">// if matrix_exp contains std::complex types </span></div><div class="line"><a name="l00736"></a><span class="lineno">  736</span>&#160;    <span class="keywordtype">bool</span> equal (</div><div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00738"></a><span class="lineno">  738</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b,</div><div class="line"><a name="l00739"></a><span class="lineno">  739</span>&#160;        <span class="keyword">const</span> matrix_exp::type::value_type epsilon = 100*std::numeric_limits&lt;matrix_exp::type::value_type&gt;::epsilon()</div><div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;    );</div><div class="line"><a name="l00752"></a><span class="lineno">  752</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00753"></a><span class="lineno">  753</span>&#160; </div><div class="line"><a name="l00754"></a><span class="lineno">  754</span>&#160;    <span class="keyword">const</span> matrix_exp pointwise_multiply (</div><div class="line"><a name="l00755"></a><span class="lineno">  755</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00756"></a><span class="lineno">  756</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b </div><div class="line"><a name="l00757"></a><span class="lineno">  757</span>&#160;    );</div><div class="line"><a name="l00773"></a><span class="lineno">  773</span>&#160;    <span class="keyword">const</span> matrix_exp pointwise_multiply (</div><div class="line"><a name="l00774"></a><span class="lineno">  774</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00775"></a><span class="lineno">  775</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b,</div><div class="line"><a name="l00776"></a><span class="lineno">  776</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; c </div><div class="line"><a name="l00777"></a><span class="lineno">  777</span>&#160;    );</div><div class="line"><a name="l00782"></a><span class="lineno">  782</span>&#160;    <span class="keyword">const</span> matrix_exp pointwise_multiply (</div><div class="line"><a name="l00783"></a><span class="lineno">  783</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00784"></a><span class="lineno">  784</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b,</div><div class="line"><a name="l00785"></a><span class="lineno">  785</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; c,</div><div class="line"><a name="l00786"></a><span class="lineno">  786</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; d </div><div class="line"><a name="l00787"></a><span class="lineno">  787</span>&#160;    );</div><div class="line"><a name="l00792"></a><span class="lineno">  792</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00793"></a><span class="lineno">  793</span>&#160; </div><div class="line"><a name="l00794"></a><span class="lineno">  794</span>&#160;    <span class="keyword">const</span> matrix_exp join_rows (</div><div class="line"><a name="l00795"></a><span class="lineno">  795</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00796"></a><span class="lineno">  796</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b </div><div class="line"><a name="l00797"></a><span class="lineno">  797</span>&#160;    );</div><div class="line"><a name="l00815"></a><span class="lineno">  815</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00816"></a><span class="lineno">  816</span>&#160; </div><div class="line"><a name="l00817"></a><span class="lineno">  817</span>&#160;    <span class="keyword">const</span> matrix_exp join_cols (</div><div class="line"><a name="l00818"></a><span class="lineno">  818</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00819"></a><span class="lineno">  819</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b </div><div class="line"><a name="l00820"></a><span class="lineno">  820</span>&#160;    );</div><div class="line"><a name="l00838"></a><span class="lineno">  838</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00839"></a><span class="lineno">  839</span>&#160; </div><div class="line"><a name="l00840"></a><span class="lineno">  840</span>&#160;    <span class="keyword">const</span> matrix_exp tensor_product (</div><div class="line"><a name="l00841"></a><span class="lineno">  841</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; a,</div><div class="line"><a name="l00842"></a><span class="lineno">  842</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; b </div><div class="line"><a name="l00843"></a><span class="lineno">  843</span>&#160;    );</div><div class="line"><a name="l00857"></a><span class="lineno">  857</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00858"></a><span class="lineno">  858</span>&#160; </div><div class="line"><a name="l00859"></a><span class="lineno">  859</span>&#160;    <span class="keyword">const</span> matrix_exp cartesian_product (</div><div class="line"><a name="l00860"></a><span class="lineno">  860</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; A,</div><div class="line"><a name="l00861"></a><span class="lineno">  861</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; B </div><div class="line"><a name="l00862"></a><span class="lineno">  862</span>&#160;    );</div><div class="line"><a name="l00885"></a><span class="lineno">  885</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00886"></a><span class="lineno">  886</span>&#160; </div><div class="line"><a name="l00887"></a><span class="lineno">  887</span>&#160;    <span class="keyword">const</span> matrix_exp scale_columns (</div><div class="line"><a name="l00888"></a><span class="lineno">  888</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00889"></a><span class="lineno">  889</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; v</div><div class="line"><a name="l00890"></a><span class="lineno">  890</span>&#160;    );</div><div class="line"><a name="l00910"></a><span class="lineno">  910</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00911"></a><span class="lineno">  911</span>&#160; </div><div class="line"><a name="l00912"></a><span class="lineno">  912</span>&#160;    <span class="keyword">const</span> matrix_exp scale_rows (</div><div class="line"><a name="l00913"></a><span class="lineno">  913</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00914"></a><span class="lineno">  914</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; v</div><div class="line"><a name="l00915"></a><span class="lineno">  915</span>&#160;    );</div><div class="line"><a name="l00935"></a><span class="lineno">  935</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00936"></a><span class="lineno">  936</span>&#160; </div><div class="line"><a name="l00937"></a><span class="lineno">  937</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00938"></a><span class="lineno">  938</span>&#160;    <span class="keywordtype">void</span> sort_columns (</div><div class="line"><a name="l00939"></a><span class="lineno">  939</span>&#160;        matrix&lt;T&gt;&amp; m,</div><div class="line"><a name="l00940"></a><span class="lineno">  940</span>&#160;        matrix&lt;T&gt;&amp; v</div><div class="line"><a name="l00941"></a><span class="lineno">  941</span>&#160;    );</div><div class="line"><a name="l00957"></a><span class="lineno">  957</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00958"></a><span class="lineno">  958</span>&#160; </div><div class="line"><a name="l00959"></a><span class="lineno">  959</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00960"></a><span class="lineno">  960</span>&#160;    <span class="keywordtype">void</span> rsort_columns (</div><div class="line"><a name="l00961"></a><span class="lineno">  961</span>&#160;        matrix&lt;T&gt;&amp; m,</div><div class="line"><a name="l00962"></a><span class="lineno">  962</span>&#160;        matrix&lt;T&gt;&amp; v</div><div class="line"><a name="l00963"></a><span class="lineno">  963</span>&#160;    );</div><div class="line"><a name="l00979"></a><span class="lineno">  979</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00980"></a><span class="lineno">  980</span>&#160; </div><div class="line"><a name="l00981"></a><span class="lineno">  981</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> length_squared (</div><div class="line"><a name="l00982"></a><span class="lineno">  982</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00983"></a><span class="lineno">  983</span>&#160;    );</div><div class="line"><a name="l00992"></a><span class="lineno">  992</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00993"></a><span class="lineno">  993</span>&#160; </div><div class="line"><a name="l00994"></a><span class="lineno">  994</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> length (</div><div class="line"><a name="l00995"></a><span class="lineno">  995</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00996"></a><span class="lineno">  996</span>&#160;    );</div><div class="line"><a name="l01009"></a><span class="lineno"> 1009</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01010"></a><span class="lineno"> 1010</span>&#160; </div><div class="line"><a name="l01011"></a><span class="lineno"> 1011</span>&#160;    <span class="keywordtype">bool</span> is_row_vector (</div><div class="line"><a name="l01012"></a><span class="lineno"> 1012</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01013"></a><span class="lineno"> 1013</span>&#160;    );</div><div class="line"><a name="l01022"></a><span class="lineno"> 1022</span>&#160;    <span class="keywordtype">bool</span> is_col_vector (</div><div class="line"><a name="l01023"></a><span class="lineno"> 1023</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01024"></a><span class="lineno"> 1024</span>&#160;    );</div><div class="line"><a name="l01033"></a><span class="lineno"> 1033</span>&#160;    <span class="keywordtype">bool</span> is_vector (</div><div class="line"><a name="l01034"></a><span class="lineno"> 1034</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01035"></a><span class="lineno"> 1035</span>&#160;    );</div><div class="line"><a name="l01044"></a><span class="lineno"> 1044</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01045"></a><span class="lineno"> 1045</span>&#160; </div><div class="line"><a name="l01046"></a><span class="lineno"> 1046</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="namespacedlib.html#a369801788996a62c66394fe6cf05e68a">is_finite</a> (</div><div class="line"><a name="l01047"></a><span class="lineno"> 1047</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01048"></a><span class="lineno"> 1048</span>&#160;    );</div><div class="line"><a name="l01055"></a><span class="lineno"> 1055</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01056"></a><span class="lineno"> 1056</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01057"></a><span class="lineno"> 1057</span>&#160;<span class="comment">//                      Thresholding relational operators </span></div><div class="line"><a name="l01058"></a><span class="lineno"> 1058</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01059"></a><span class="lineno"> 1059</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01060"></a><span class="lineno"> 1060</span>&#160; </div><div class="line"><a name="l01061"></a><span class="lineno"> 1061</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01062"></a><span class="lineno"> 1062</span>&#160;    <span class="keyword">const</span> matrix_exp operator&lt; (</div><div class="line"><a name="l01063"></a><span class="lineno"> 1063</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01064"></a><span class="lineno"> 1064</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01065"></a><span class="lineno"> 1065</span>&#160;    );</div><div class="line"><a name="l01082"></a><span class="lineno"> 1082</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01083"></a><span class="lineno"> 1083</span>&#160; </div><div class="line"><a name="l01084"></a><span class="lineno"> 1084</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01085"></a><span class="lineno"> 1085</span>&#160;    <span class="keyword">const</span> matrix_exp operator&lt; (</div><div class="line"><a name="l01086"></a><span class="lineno"> 1086</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01087"></a><span class="lineno"> 1087</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01088"></a><span class="lineno"> 1088</span>&#160;    );</div><div class="line"><a name="l01105"></a><span class="lineno"> 1105</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01106"></a><span class="lineno"> 1106</span>&#160; </div><div class="line"><a name="l01107"></a><span class="lineno"> 1107</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01108"></a><span class="lineno"> 1108</span>&#160;    <span class="keyword">const</span> matrix_exp operator&lt;= (</div><div class="line"><a name="l01109"></a><span class="lineno"> 1109</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01110"></a><span class="lineno"> 1110</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01111"></a><span class="lineno"> 1111</span>&#160;    );</div><div class="line"><a name="l01128"></a><span class="lineno"> 1128</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01129"></a><span class="lineno"> 1129</span>&#160; </div><div class="line"><a name="l01130"></a><span class="lineno"> 1130</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01131"></a><span class="lineno"> 1131</span>&#160;    <span class="keyword">const</span> matrix_exp operator&lt;= (</div><div class="line"><a name="l01132"></a><span class="lineno"> 1132</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01133"></a><span class="lineno"> 1133</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01134"></a><span class="lineno"> 1134</span>&#160;    );</div><div class="line"><a name="l01151"></a><span class="lineno"> 1151</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01152"></a><span class="lineno"> 1152</span>&#160; </div><div class="line"><a name="l01153"></a><span class="lineno"> 1153</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01154"></a><span class="lineno"> 1154</span>&#160;    <span class="keyword">const</span> matrix_exp operator&gt; (</div><div class="line"><a name="l01155"></a><span class="lineno"> 1155</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01156"></a><span class="lineno"> 1156</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01157"></a><span class="lineno"> 1157</span>&#160;    );</div><div class="line"><a name="l01174"></a><span class="lineno"> 1174</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01175"></a><span class="lineno"> 1175</span>&#160; </div><div class="line"><a name="l01176"></a><span class="lineno"> 1176</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01177"></a><span class="lineno"> 1177</span>&#160;    <span class="keyword">const</span> matrix_exp operator&gt; (</div><div class="line"><a name="l01178"></a><span class="lineno"> 1178</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01179"></a><span class="lineno"> 1179</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01180"></a><span class="lineno"> 1180</span>&#160;    );</div><div class="line"><a name="l01197"></a><span class="lineno"> 1197</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01198"></a><span class="lineno"> 1198</span>&#160; </div><div class="line"><a name="l01199"></a><span class="lineno"> 1199</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01200"></a><span class="lineno"> 1200</span>&#160;    <span class="keyword">const</span> matrix_exp operator&gt;= (</div><div class="line"><a name="l01201"></a><span class="lineno"> 1201</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01202"></a><span class="lineno"> 1202</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01203"></a><span class="lineno"> 1203</span>&#160;    );</div><div class="line"><a name="l01220"></a><span class="lineno"> 1220</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01221"></a><span class="lineno"> 1221</span>&#160; </div><div class="line"><a name="l01222"></a><span class="lineno"> 1222</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01223"></a><span class="lineno"> 1223</span>&#160;    <span class="keyword">const</span> matrix_exp operator&gt;= (</div><div class="line"><a name="l01224"></a><span class="lineno"> 1224</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01225"></a><span class="lineno"> 1225</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01226"></a><span class="lineno"> 1226</span>&#160;    );</div><div class="line"><a name="l01243"></a><span class="lineno"> 1243</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01244"></a><span class="lineno"> 1244</span>&#160; </div><div class="line"><a name="l01245"></a><span class="lineno"> 1245</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01246"></a><span class="lineno"> 1246</span>&#160;    <span class="keyword">const</span> matrix_exp operator== (</div><div class="line"><a name="l01247"></a><span class="lineno"> 1247</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01248"></a><span class="lineno"> 1248</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01249"></a><span class="lineno"> 1249</span>&#160;    );</div><div class="line"><a name="l01266"></a><span class="lineno"> 1266</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01267"></a><span class="lineno"> 1267</span>&#160; </div><div class="line"><a name="l01268"></a><span class="lineno"> 1268</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01269"></a><span class="lineno"> 1269</span>&#160;    <span class="keyword">const</span> matrix_exp operator== (</div><div class="line"><a name="l01270"></a><span class="lineno"> 1270</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01271"></a><span class="lineno"> 1271</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01272"></a><span class="lineno"> 1272</span>&#160;    );</div><div class="line"><a name="l01289"></a><span class="lineno"> 1289</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01290"></a><span class="lineno"> 1290</span>&#160; </div><div class="line"><a name="l01291"></a><span class="lineno"> 1291</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01292"></a><span class="lineno"> 1292</span>&#160;    <span class="keyword">const</span> matrix_exp operator!= (</div><div class="line"><a name="l01293"></a><span class="lineno"> 1293</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01294"></a><span class="lineno"> 1294</span>&#160;        <span class="keyword">const</span> S&amp; s</div><div class="line"><a name="l01295"></a><span class="lineno"> 1295</span>&#160;    );</div><div class="line"><a name="l01312"></a><span class="lineno"> 1312</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01313"></a><span class="lineno"> 1313</span>&#160; </div><div class="line"><a name="l01314"></a><span class="lineno"> 1314</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> S&gt;</div><div class="line"><a name="l01315"></a><span class="lineno"> 1315</span>&#160;    <span class="keyword">const</span> matrix_exp operator!= (</div><div class="line"><a name="l01316"></a><span class="lineno"> 1316</span>&#160;        <span class="keyword">const</span> S&amp; s,</div><div class="line"><a name="l01317"></a><span class="lineno"> 1317</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01318"></a><span class="lineno"> 1318</span>&#160;    );</div><div class="line"><a name="l01335"></a><span class="lineno"> 1335</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01336"></a><span class="lineno"> 1336</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01337"></a><span class="lineno"> 1337</span>&#160;<span class="comment">//                              Statistics</span></div><div class="line"><a name="l01338"></a><span class="lineno"> 1338</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01339"></a><span class="lineno"> 1339</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01340"></a><span class="lineno"> 1340</span>&#160; </div><div class="line"><a name="l01341"></a><span class="lineno"> 1341</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> min (</div><div class="line"><a name="l01342"></a><span class="lineno"> 1342</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01343"></a><span class="lineno"> 1343</span>&#160;    );</div><div class="line"><a name="l01353"></a><span class="lineno"> 1353</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01354"></a><span class="lineno"> 1354</span>&#160; </div><div class="line"><a name="l01355"></a><span class="lineno"> 1355</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> max (</div><div class="line"><a name="l01356"></a><span class="lineno"> 1356</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01357"></a><span class="lineno"> 1357</span>&#160;    );</div><div class="line"><a name="l01367"></a><span class="lineno"> 1367</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01368"></a><span class="lineno"> 1368</span>&#160; </div><div class="line"><a name="l01369"></a><span class="lineno"> 1369</span>&#160;    <span class="keywordtype">void</span> find_min_and_max (</div><div class="line"><a name="l01370"></a><span class="lineno"> 1370</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01371"></a><span class="lineno"> 1371</span>&#160;        <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; min_val,</div><div class="line"><a name="l01372"></a><span class="lineno"> 1372</span>&#160;        <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; max_val</div><div class="line"><a name="l01373"></a><span class="lineno"> 1373</span>&#160;    );</div><div class="line"><a name="l01384"></a><span class="lineno"> 1384</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01385"></a><span class="lineno"> 1385</span>&#160; </div><div class="line"><a name="l01386"></a><span class="lineno"> 1386</span>&#160;    <span class="keywordtype">long</span> index_of_max (</div><div class="line"><a name="l01387"></a><span class="lineno"> 1387</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01388"></a><span class="lineno"> 1388</span>&#160;    );</div><div class="line"><a name="l01398"></a><span class="lineno"> 1398</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01399"></a><span class="lineno"> 1399</span>&#160; </div><div class="line"><a name="l01400"></a><span class="lineno"> 1400</span>&#160;    <span class="keywordtype">long</span> index_of_min (</div><div class="line"><a name="l01401"></a><span class="lineno"> 1401</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01402"></a><span class="lineno"> 1402</span>&#160;    );</div><div class="line"><a name="l01412"></a><span class="lineno"> 1412</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01413"></a><span class="lineno"> 1413</span>&#160; </div><div class="line"><a name="l01414"></a><span class="lineno"> 1414</span>&#160;    point max_point (</div><div class="line"><a name="l01415"></a><span class="lineno"> 1415</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01416"></a><span class="lineno"> 1416</span>&#160;    );</div><div class="line"><a name="l01425"></a><span class="lineno"> 1425</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01426"></a><span class="lineno"> 1426</span>&#160; </div><div class="line"><a name="l01427"></a><span class="lineno"> 1427</span>&#160;    <a class="code" href="classdlib_1_1vector.html">dlib::vector&lt;double,2&gt;</a> max_point_interpolated (</div><div class="line"><a name="l01428"></a><span class="lineno"> 1428</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01429"></a><span class="lineno"> 1429</span>&#160;    );</div><div class="line"><a name="l01440"></a><span class="lineno"> 1440</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01441"></a><span class="lineno"> 1441</span>&#160; </div><div class="line"><a name="l01442"></a><span class="lineno"> 1442</span>&#160;    point min_point (</div><div class="line"><a name="l01443"></a><span class="lineno"> 1443</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01444"></a><span class="lineno"> 1444</span>&#160;    );</div><div class="line"><a name="l01453"></a><span class="lineno"> 1453</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01454"></a><span class="lineno"> 1454</span>&#160; </div><div class="line"><a name="l01455"></a><span class="lineno"> 1455</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> sum (</div><div class="line"><a name="l01456"></a><span class="lineno"> 1456</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01457"></a><span class="lineno"> 1457</span>&#160;    );</div><div class="line"><a name="l01463"></a><span class="lineno"> 1463</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01464"></a><span class="lineno"> 1464</span>&#160; </div><div class="line"><a name="l01465"></a><span class="lineno"> 1465</span>&#160;    <span class="keyword">const</span> matrix_exp sum_rows (</div><div class="line"><a name="l01466"></a><span class="lineno"> 1466</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01467"></a><span class="lineno"> 1467</span>&#160;    );</div><div class="line"><a name="l01481"></a><span class="lineno"> 1481</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01482"></a><span class="lineno"> 1482</span>&#160; </div><div class="line"><a name="l01483"></a><span class="lineno"> 1483</span>&#160;    <span class="keyword">const</span> matrix_exp sum_cols (</div><div class="line"><a name="l01484"></a><span class="lineno"> 1484</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01485"></a><span class="lineno"> 1485</span>&#160;    );</div><div class="line"><a name="l01499"></a><span class="lineno"> 1499</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01500"></a><span class="lineno"> 1500</span>&#160; </div><div class="line"><a name="l01501"></a><span class="lineno"> 1501</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> prod (</div><div class="line"><a name="l01502"></a><span class="lineno"> 1502</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01503"></a><span class="lineno"> 1503</span>&#160;    );</div><div class="line"><a name="l01509"></a><span class="lineno"> 1509</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01510"></a><span class="lineno"> 1510</span>&#160; </div><div class="line"><a name="l01511"></a><span class="lineno"> 1511</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> mean (</div><div class="line"><a name="l01512"></a><span class="lineno"> 1512</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01513"></a><span class="lineno"> 1513</span>&#160;    );</div><div class="line"><a name="l01520"></a><span class="lineno"> 1520</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01521"></a><span class="lineno"> 1521</span>&#160; </div><div class="line"><a name="l01522"></a><span class="lineno"> 1522</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> variance (</div><div class="line"><a name="l01523"></a><span class="lineno"> 1523</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01524"></a><span class="lineno"> 1524</span>&#160;    );</div><div class="line"><a name="l01531"></a><span class="lineno"> 1531</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01532"></a><span class="lineno"> 1532</span>&#160; </div><div class="line"><a name="l01533"></a><span class="lineno"> 1533</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> stddev (</div><div class="line"><a name="l01534"></a><span class="lineno"> 1534</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01535"></a><span class="lineno"> 1535</span>&#160;    );</div><div class="line"><a name="l01541"></a><span class="lineno"> 1541</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01542"></a><span class="lineno"> 1542</span>&#160; </div><div class="line"><a name="l01543"></a><span class="lineno"> 1543</span>&#160;    <span class="keyword">const</span> matrix covariance (</div><div class="line"><a name="l01544"></a><span class="lineno"> 1544</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01545"></a><span class="lineno"> 1545</span>&#160;    );</div><div class="line"><a name="l01565"></a><span class="lineno"> 1565</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01566"></a><span class="lineno"> 1566</span>&#160; </div><div class="line"><a name="l01567"></a><span class="lineno"> 1567</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> rand_gen&gt;</div><div class="line"><a name="l01568"></a><span class="lineno"> 1568</span>&#160;    <span class="keyword">const</span> matrix&lt;double&gt; randm( </div><div class="line"><a name="l01569"></a><span class="lineno"> 1569</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l01570"></a><span class="lineno"> 1570</span>&#160;        <span class="keywordtype">long</span> nc,</div><div class="line"><a name="l01571"></a><span class="lineno"> 1571</span>&#160;        rand_gen&amp; rnd</div><div class="line"><a name="l01572"></a><span class="lineno"> 1572</span>&#160;    );</div><div class="line"><a name="l01588"></a><span class="lineno"> 1588</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01589"></a><span class="lineno"> 1589</span>&#160; </div><div class="line"><a name="l01590"></a><span class="lineno"> 1590</span>&#160;    <span class="keyword">inline</span> <span class="keyword">const</span> matrix&lt;double&gt; randm( </div><div class="line"><a name="l01591"></a><span class="lineno"> 1591</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l01592"></a><span class="lineno"> 1592</span>&#160;        <span class="keywordtype">long</span> nc</div><div class="line"><a name="l01593"></a><span class="lineno"> 1593</span>&#160;    );</div><div class="line"><a name="l01608"></a><span class="lineno"> 1608</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01609"></a><span class="lineno"> 1609</span>&#160; </div><div class="line"><a name="l01610"></a><span class="lineno"> 1610</span>&#160;    <span class="keyword">inline</span> <span class="keyword">const</span> matrix_exp gaussian_randm (</div><div class="line"><a name="l01611"></a><span class="lineno"> 1611</span>&#160;        <span class="keywordtype">long</span> nr,</div><div class="line"><a name="l01612"></a><span class="lineno"> 1612</span>&#160;        <span class="keywordtype">long</span> nc,</div><div class="line"><a name="l01613"></a><span class="lineno"> 1613</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> seed = 0</div><div class="line"><a name="l01614"></a><span class="lineno"> 1614</span>&#160;    );</div><div class="line"><a name="l01635"></a><span class="lineno"> 1635</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01636"></a><span class="lineno"> 1636</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01637"></a><span class="lineno"> 1637</span>&#160;<span class="comment">//                                 Pixel and Image Utilities</span></div><div class="line"><a name="l01638"></a><span class="lineno"> 1638</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01639"></a><span class="lineno"> 1639</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01640"></a><span class="lineno"> 1640</span>&#160; </div><div class="line"><a name="l01641"></a><span class="lineno"> 1641</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l01642"></a><span class="lineno"> 1642</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l01643"></a><span class="lineno"> 1643</span>&#160;        <span class="keyword">typename</span> P</div><div class="line"><a name="l01644"></a><span class="lineno"> 1644</span>&#160;        &gt;</div><div class="line"><a name="l01645"></a><span class="lineno"> 1645</span>&#160;    <span class="keyword">const</span> matrix_exp pixel_to_vector (</div><div class="line"><a name="l01646"></a><span class="lineno"> 1646</span>&#160;        <span class="keyword">const</span> P&amp; pixel</div><div class="line"><a name="l01647"></a><span class="lineno"> 1647</span>&#160;    );</div><div class="line"><a name="l01668"></a><span class="lineno"> 1668</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01669"></a><span class="lineno"> 1669</span>&#160; </div><div class="line"><a name="l01670"></a><span class="lineno"> 1670</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l01671"></a><span class="lineno"> 1671</span>&#160;        <span class="keyword">typename</span> P</div><div class="line"><a name="l01672"></a><span class="lineno"> 1672</span>&#160;        &gt;</div><div class="line"><a name="l01673"></a><span class="lineno"> 1673</span>&#160;    <span class="keywordtype">void</span> vector_to_pixel (</div><div class="line"><a name="l01674"></a><span class="lineno"> 1674</span>&#160;        P&amp; pixel,</div><div class="line"><a name="l01675"></a><span class="lineno"> 1675</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; vector </div><div class="line"><a name="l01676"></a><span class="lineno"> 1676</span>&#160;    );</div><div class="line"><a name="l01695"></a><span class="lineno"> 1695</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01696"></a><span class="lineno"> 1696</span>&#160; </div><div class="line"><a name="l01697"></a><span class="lineno"> 1697</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l01698"></a><span class="lineno"> 1698</span>&#160;        <span class="keywordtype">long</span> lower,</div><div class="line"><a name="l01699"></a><span class="lineno"> 1699</span>&#160;        <span class="keywordtype">long</span> upper </div><div class="line"><a name="l01700"></a><span class="lineno"> 1700</span>&#160;        &gt;</div><div class="line"><a name="l01701"></a><span class="lineno"> 1701</span>&#160;    <span class="keyword">const</span> matrix_exp clamp (</div><div class="line"><a name="l01702"></a><span class="lineno"> 1702</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l01703"></a><span class="lineno"> 1703</span>&#160;    );</div><div class="line"><a name="l01718"></a><span class="lineno"> 1718</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01719"></a><span class="lineno"> 1719</span>&#160; </div><div class="line"><a name="l01720"></a><span class="lineno"> 1720</span>&#160;    <span class="keyword">const</span> matrix_exp clamp (</div><div class="line"><a name="l01721"></a><span class="lineno"> 1721</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01722"></a><span class="lineno"> 1722</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; lower,</div><div class="line"><a name="l01723"></a><span class="lineno"> 1723</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; upper</div><div class="line"><a name="l01724"></a><span class="lineno"> 1724</span>&#160;    );</div><div class="line"><a name="l01739"></a><span class="lineno"> 1739</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01740"></a><span class="lineno"> 1740</span>&#160; </div><div class="line"><a name="l01741"></a><span class="lineno"> 1741</span>&#160;    <span class="keyword">const</span> matrix_exp clamp (</div><div class="line"><a name="l01742"></a><span class="lineno"> 1742</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01743"></a><span class="lineno"> 1743</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; lower,</div><div class="line"><a name="l01744"></a><span class="lineno"> 1744</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; upper</div><div class="line"><a name="l01745"></a><span class="lineno"> 1745</span>&#160;    );</div><div class="line"><a name="l01766"></a><span class="lineno"> 1766</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01767"></a><span class="lineno"> 1767</span>&#160; </div><div class="line"><a name="l01768"></a><span class="lineno"> 1768</span>&#160;    <span class="keyword">const</span> matrix_exp lowerbound (</div><div class="line"><a name="l01769"></a><span class="lineno"> 1769</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01770"></a><span class="lineno"> 1770</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; thresh </div><div class="line"><a name="l01771"></a><span class="lineno"> 1771</span>&#160;    );</div><div class="line"><a name="l01784"></a><span class="lineno"> 1784</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01785"></a><span class="lineno"> 1785</span>&#160; </div><div class="line"><a name="l01786"></a><span class="lineno"> 1786</span>&#160;    <span class="keyword">const</span> matrix_exp upperbound (</div><div class="line"><a name="l01787"></a><span class="lineno"> 1787</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l01788"></a><span class="lineno"> 1788</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a>&amp; thresh </div><div class="line"><a name="l01789"></a><span class="lineno"> 1789</span>&#160;    );</div><div class="line"><a name="l01802"></a><span class="lineno"> 1802</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l01803"></a><span class="lineno"> 1803</span>&#160; </div><div class="line"><a name="l01804"></a><span class="lineno"> 1804</span>&#160;}</div><div class="line"><a name="l01805"></a><span class="lineno"> 1805</span>&#160; </div><div class="line"><a name="l01806"></a><span class="lineno"> 1806</span>&#160;<span class="preprocessor">#endif // DLIB_MATRIx_UTILITIES_ABSTRACT_</span></div><div class="line"><a name="l01807"></a><span class="lineno"> 1807</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1matrix__exp_html_a039e80e9a67ddd1abaa4a1004dab7254"><div class="ttname"><a href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">dlib::matrix_exp::type</a></div><div class="ttdeci">matrix_traits&lt; EXP &gt;::type type</div><div class="ttdef"><b>Definition:</b> matrix_exp.h:126</div></div>
<div class="ttc" id="aclassdlib_1_1vector_html"><div class="ttname"><a href="classdlib_1_1vector.html">dlib::vector&lt; double, 2 &gt;</a></div></div>
<div class="ttc" id="anamespacedlib_html_a369801788996a62c66394fe6cf05e68a"><div class="ttname"><a href="namespacedlib.html#a369801788996a62c66394fe6cf05e68a">dlib::is_finite</a></div><div class="ttdeci">enable_if&lt; is_built_in_scalar_type&lt; T &gt;, bool &gt;::type is_finite(const T &amp;value)</div><div class="ttdef"><b>Definition:</b> algs.h:645</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
